;; SPDX-FileCopyrightText 2024 toastal <toastal@posteo.net>
;; SPDX-License-Identifier: LGPL-2.1-or-later
; extends

("fun" @keyword.function @conceal (#set! conceal "λ"))
("end" @keyword.function @conceal (#set! conceal "◊"))
("->" @operator @conceal (#set! conceal "→"))
("<-" @operator @conceal (#set! conceal "←"))
("=>" @operator @conceal (#set! conceal "⇒"))
("<=" @operator @conceal (#set! conceal "⇐"))
("=" @operator @conceal (#set! conceal "≕"))
(":=" @operator @conceal (#set! conceal "≔"))
("?=" @operator @conceal (#set! conceal "≟"))

("==" @operator @conceal (#set! conceal "="))
("/=" @operator @conceal (#set! conceal "≠"))
("=:=" @operator @conceal (#set! conceal "≡"))
("=/=" @operator @conceal (#set! conceal "≢"))
("=<" @operator @conceal (#set! conceal "≤"))
(">=" @operator @conceal (#set! conceal "≥"))
("*" @operator @conceal (#set! conceal "×"))
; welp… upstream parser is broken currently
(ERROR ("/" @operator @conceal) !arity (#set! conceal "÷"))
("not" @operator @conceal (#set! conceal "¬"))
("and" @operator @conceal (#set! conceal "∧"))
("or" @operator @conceal (#set! conceal "∨"))
("xor" @operator @conceal (#set! conceal "⊻"))

(type_sig (expr_args args: (call (atom) @type.definition @conceal (#eq? @type.definition "integer"))) (#set! conceal "ℤ"))
(type_sig (pipe lhs: (atom) @lhs rhs: (atom) @rhs (#any-of? @lhs "true" "false") (#any-of? @rhs "true" "false") (#not-eq? @lhs @rhs)) @boolean @conceal (#set! conceal "𝔹"))
