;; SPDX-FileCopyrightText 2023–2024 toastal <toastal@posteo.net>
;; SPDX-License-Identifier: LGPL-2.1-or-later
; extends

("function" @keyword.function @conceal (#set! conceal "λ"))
("end" @keyword.function @conceal (#set! conceal "◊"))
("return" @keyword.return @conceal (#set! conceal "⮡"))
(assignment_statement ("=" @operator.assignment @conceal (#set! conceal "←")))
(field ("=" @punctuation.delimeter @conceal (#set! conceal "≔")))

("and" @keyword.operator @conceal (#set! conceal "∧"))
("or" @keyword.operator @conceal (#set! conceal "∨"))
("not" @operator @conceal (#set! conceal "¬"))

("==" @operator @conceal (#set! conceal "="))
("~=" @operator @conceal (#set! conceal "≠"))
("<=" @operator @conceal (#set! conceal "≤"))
(">=" @operator @conceal (#set! conceal "≥"))
(".." @operator @conceal (#set! conceal "‥"))
("/" @operator @conceal (#set! conceal "÷"))
("*" @operator @conceal (#set! conceal "×"))

((((dot_index_expression table: (identifier) @variable field: (identifier) @field) @function.call)
  (#eq? @variable "math") (#eq? @field "ceil"))
 (#set! conceal "⌈"))
((((dot_index_expression table: (identifier) @variable field: (identifier) @field) @function.call)
  (#eq? @variable "math") (#eq? @field "floor"))
 (#set! conceal "⌊"))
((((dot_index_expression table: (identifier) @variable field: (identifier) @field) @function.call)
  (#eq? @variable "math") (#eq? @field "round"))
 (#set! conceal "⁅"))
((((dot_index_expression table: (identifier) @variable field: (identifier) @field) @constant)
  (#eq? @variable "math") (#eq? @field "pi"))
 (#set! conceal "π"))
((((dot_index_expression table: (identifier) @variable field: (identifier) @field) @function.call)
  (#eq? @variable "math") (#eq? @field "sqrt"))
 (#set! conceal "√"))
